<?php
/**
 * @package Mailchimp Single Opt-in Widget
 */
/*
Plugin Name: Mailchimp Single Opt-in Widget
Plugin URI: http://wordpressdev.net/plugins/
Description: Adds a MailChimp single opt-in subscription form widget to a site. 
Version: 1.01
Author: Alan Pasho
Author URI: http://wordpressdev.net/
License: GPLv2 or later
Text Domain: mc-single-opt-in
*/

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
*/

if(!defined('MCSOW_PLUGIN_URL')) {
	define('MCSOW_PLUGIN_URL', plugin_dir_url( __FILE__ ));
}
 
function mcsow_enqueue_script() {
    
  wp_register_script( "mcsow_script", MCSOW_PLUGIN_URL . 'mailchimp-single-opt-in.js', array('jquery') );
  wp_localize_script( 'mcsow_script', 'mcsow_ajax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' )));        

  wp_enqueue_script("jquery");
  wp_enqueue_script( 'mcsow_script' ); 
}

add_action( 'wp_enqueue_scripts', 'mcsow_enqueue_script' );   

function mcsow_admin_menu()
{
	add_options_page( __('Mailchimp Single Opt-In', 'mc-single-opt-in'), __('Mailchimp Single Opt-In', 'mc-single-opt-in'), 'manage_options', 'mc-single-opt-in', 'mcsow_admin' );
}

add_action('admin_menu', 'mcsow_admin_menu' ); 

if(!defined('MCSOW_PLUGIN_URL')) {
	define('MCSOW_PLUGIN_URL', plugin_dir_url( __FILE__ ));
}

function mcsow_enqueue_style() {
   wp_enqueue_style('mcsow-style', MCSOW_PLUGIN_URL . '/css/admin.css');
}

add_action( 'admin_enqueue_scripts', 'mcsow_enqueue_style' );

function mcsow_admin (){
  
if( 'POST' == $_SERVER['REQUEST_METHOD'] && !empty( $_POST['action'] ) &&  $_POST['action'] == "new_record") {

  $api_key = trim(stripslashes(strip_tags($_POST['api_key'])));
  $list_id = trim(stripslashes(strip_tags($_POST['list_id'])));
  $placeholder_text = trim(stripslashes(strip_tags($_POST['placeholder_text'])));
  $field_label = trim(stripslashes(strip_tags($_POST['field_label'])));
  $button_text = trim(stripslashes(strip_tags($_POST['button_text'])));
  $thank_you_msg = trim(stripslashes(strip_tags($_POST['thank_you_msg'])));
  
  update_option( 'mc_sow_api_key', $api_key );
  update_option( 'mc_sow_list_id', $list_id );
  update_option( 'mc_sow_ph_text', $placeholder_text );
  update_option( 'mc_sow_label', $field_label );
  update_option( 'mc_sow_bt_text', $button_text );
  update_option( 'mc_sow_ty_msg', $thank_you_msg );
   
}

$api_key = get_option( 'mc_sow_api_key', '' );
$list_id = get_option( 'mc_sow_list_id', '' );
$field_label = get_option( 'mc_sow_label', __('Email Address:', 'mc-single-opt-in'));
$placeholder_text = get_option( 'mc_sow_ph_text', __('Email Address', 'mc-single-opt-in'));
$button_text = get_option( 'mc_sow_bt_text', __('Subscribe', 'mc-single-opt-in'));
$thank_you_msg = get_option( 'mc_sow_ty_msg', __('Thank you for subscribing', 'mc-single-opt-in'));


?>
<div id="mcsow_settings">
  <h1><?php _e('MailChimp&trade; Single Opt-In Widget', 'mc-single-opt-in'); ?></h1>   

  <form id="mc-single-opt-in" method="post" action="">

    <p>
      <label class="mcsow_label"><?php _e('MailChimp API Key', 'mc-single-opt-in'); ?>:</label>
      <input type="text" value="<?php echo $api_key ?>" name="api_key" id="api_key" />
    </p>  

    <p>
      <label class="mcsow_label"><?php _e('MailChimp List ID', 'mc-single-opt-in'); ?>:</label>
      <input type="text" value="<?php echo $list_id; ?>" name="list_id" id="list_id" />
    </p>
    
    <p>
      <label class="mcsow_label"><?php _e('Field label', 'mc-single-opt-in'); ?>:</label>
      <input type="text" value="<?php echo $field_label; ?>" name="field_label" id="field_label" />
    </p>
    
    <p>
      <label class="mcsow_label"><?php _e('Placeholder Text', 'mc-single-opt-in'); ?>:</label>
      <input type="text" value="<?php echo $placeholder_text; ?>" name="placeholder_text" id="placeholder_text" />
    </p>
    
    <p>
      <label class="mcsow_label"><?php _e('Button Text', 'mc-single-opt-in'); ?>:</label>
      <input type="text" value="<?php echo $button_text; ?>" name="button_text" id="button_text" />
    </p>
    
    <p>
      <label class="mcsow_label"><?php _e('Thank You Message', 'mc-single-opt-in'); ?>:</label>
      <input type="text" value="<?php echo $thank_you_msg; ?>" name="thank_you_msg" id="thank_you_msg" />
    </p>
    
    <p>
      <button type="submit">Save Options</button>
    </p>

    <input type="hidden" name="action" value="new_record" />
    <?php wp_nonce_field( 'new-post' ); ?>
    
  </form>
</div><!-- mcsow_settings -->  
  
<?php
  
}

add_action( 'widgets_init', 'load_single_opt_in_widget' );

function load_single_opt_in_widget() {
	register_widget( 'MC_Single_Opt_In_Widget' );
}

class MC_Single_Opt_In_Widget extends WP_Widget {

	/**
	 * Widget setup
	 */
	function MC_Single_Opt_In_Widget() {
		/* Widget settings */
		$widget_ops = array( 'classname' => 'MC_Single_Opt_In_Widget', 'description' => __('Displays a field and submit button to add a subscriber to an MailChimp email list', 'mc-single-opt-in') );

		/* Widget control settings */
		$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'mc_single_opt_in_widget' );

		/* Create the widget */
		$this->WP_Widget( 'mc_single_opt_in_widget', 'Sinlge Opt-in Mail Form', $widget_ops, $control_ops );
	}

	/**
	 * Display the widget
	 */
	function widget( $args, $instance ) {
		extract( $args );
    $field_label = get_option( 'mc_sow_label', __('Email Address:', 'mc-single-opt-in'));
    $placeholder_text = get_option( 'mc_sow_ph_text', __('Email Address', 'mc-single-opt-in'));
    $button_text = get_option( 'mc_sow_bt_text', __('Subscribe', 'mc-single-opt-in'));

		/* Our variables from the widget settings. */
		$title = apply_filters('widget_title', $instance['title'] );
		echo $before_widget;
    
    include 'includes/mcsow_form.php';
    
		echo $after_widget;
	}
	
	/**
	 * Update the widget settings
	 */
	function update( $new_instance, $old_instance ) {
		
		return $old_instance;
	}

	/**
	 * Displays the widget settings controls on the widget panel
	 */
	function form( $instance ) {

    echo __('Go to Settings->Mailchimp Single Opt-In to enter setttings for this widget.', 'mc-single-opt-in');		
		
	}
}

// function for the short code version of the subsciption form
function display_mc_form($atts) {
    
  $field_label = get_option( 'mc_sow_label', __('Email Address:', 'mc-single-opt-in'));
  $placeholder_text = get_option( 'mc_sow_ph_text', __('Email Address', 'mc-single-opt-in'));
  $button_text = get_option( 'mc_sow_bt_text', __('Subscribe', 'mc-single-opt-in'));
  
  $buffer = '<div id="form-container-sc">' . PHP_EOL;
  $buffer .= '      <form id="mc-embedded-subscribe-form-sc" action="" class="validate form-inline">' . PHP_EOL;
  $buffer .= '        <div class="form-group">' . PHP_EOL;
  $buffer .= '          <div class="mc-field-group">' . PHP_EOL;
  $buffer .= '            <label id="mc-sow-label-sc" for="exampleInputEmail2">' . $field_label . '</label>' . PHP_EOL;
  $buffer .= '            <input type="email" class="form-control required email" id="mce-EMAIL-sc" name="EMAIL-sc"  placeholder="' . $placeholder_text . '" value="">' . PHP_EOL;
  $buffer .= '            <button type="button" name="subscribe" id="mc-embedded-subscribe-sc" class="button btn">' . $button_text . '</button>' . PHP_EOL;
  $buffer .= '          </div>' . PHP_EOL;							
  $buffer .= '        </div>' . PHP_EOL;
  $buffer .= '        <div style="position: absolute; left: -5000px;"><input type="text" id="required_field-sc" name="required_field-sc" tabindex="-1" value=""></div>' . PHP_EOL;
  $buffer .= '        <div id="mce-responses" class="clear">' . PHP_EOL;
  $buffer .= '          <div class="response" id="mce-error-response-sc" style="display:none"></div>' . PHP_EOL;
  $buffer .= '          <div class="response" id="mce-success-response-sc" style="display:none"></div>' . PHP_EOL;
  $buffer .= '        </div>' . PHP_EOL;    
  $buffer .= wp_nonce_field( 'wp_mcsow_subscribe_cs', '_wpnonce-sc' ) . PHP_EOL;
  $buffer .= '      </form>' . PHP_EOL;
  $buffer .= '    </div>' . PHP_EOL;
  
  return $buffer;
    
}
//[display-mc-form]
add_shortcode('display-mc-form', 'display_mc_form');

// because there are two subscription forms that could appear on the same page
// there are two separate ajax calls. We check the nonce in separate functions 
// and then call mcsow_do_subscribe() to submit the email 

add_action("wp_ajax_nopriv_mcsow_subscribe", "mcsow_subscribe");

add_action("wp_ajax_mcsow_subscribe", "mcsow_subscribe");

add_action("wp_ajax_nopriv_mcsow_subscribe_sc", "mcsow_subscribe_sc");

add_action("wp_ajax_mcsow_subscribe_sc", "mcsow_subscribe_sc");

//function for the subscription short code
function mcsow_subscribe_sc () {

  if ( !wp_verify_nonce( $_REQUEST['nonce'], "wp_mcsow_subscribe_cs")) {
    exit(__('missing nonce!'));
  } 
  mcsow_do_subscribe ();
    
}  

//function for the subscription widget
function mcsow_subscribe () {
    
  if ( !wp_verify_nonce( $_REQUEST['nonce'], "wp_mcsow_subscribe")) {
    exit(__('missing nonce!'));
  } 
  mcsow_do_subscribe ();

}

// submit the email address and display the thank you or error message
function mcsow_do_subscribe () {
  
  if ((isset($_REQUEST['email'])) && (strlen(trim($_REQUEST['email'])) > 0)) 
    $email = trim(stripslashes(strip_tags($_REQUEST['email'])));
  else
    $email = '';

  require_once 'includes/MCAPI.class.php';

  $thank_you_msg = get_option( 'mc_sow_ty_msg', __('Thank you for subscribing', 'mc-single-opt-in'));
  $apikey = get_option( 'mc_sow_api_key', '' );
  $listId = get_option( 'mc_sow_list_id', '' );
  $apiUrl = 'http://api.mailchimp.com/1.3/';

  $api = new MCAPI($apikey);

  $merge_vars = null;

  if($email !== '') {

  $retval = $api->listSubscribe( $listId, $email, $merge_vars );

    if ($api->errorCode){
      echo "<p id='replace_form'>Error: $api->errorCode, $api->errorMessage</p>";
    } else {
        echo '<p id="replace_form">' . $thank_you_msg . '</p>';
    }
  }

  die();
  
}

?>